---
layout: default
title: manifesto
---

This page is kind of like a manifesto or philosophy (something like the UNIX philosophy) about what goes and doesn't go into the webpages here.

## No dependency on CSS and JS
Doing this helps with screen readers that get confused trying to figure out how your page is meant to be interpreted.

Text mode browsers will also benefit from this, as your page will look fine without CSS or JS.

Single page websites show how this rule is important, as they are completely unusable without JavaScript.

## Minimal CSS
This helps with the rule above, and keeping your site looking consistent.
Just make it look nice and readable.

## Avoid JS
JS is only adequate for web apps - apps that run in the browser just to avoid troublesome installation. Even then, no two JS engines work the same way.

A common use for JS is tracking which is recently quite frowned upon.

## Don't bloat
A ton of things are added to websites that add nothing to, or worsen the browsing experience. Here are some common things that bloat websites:

### Newsletter popups
Don't slam your newsletter in everyone's face - if you have one, just put a small subscription box somewhere on the bottom, top or a side bar.

### Share buttons
Share buttons are rarely used, and when they are, you usually can't specify where to share to which makes them useless.

Users will generally share manually or share using their mobile browser (which also gives them their own share targets)

These are also often frowned upon if the share button is an image coming from the social network itself, which allows them to track you via cookies and the Referer header.

### Comment sections on every page
Only add comment sections if you expect them to be used on a specific page.

## Get to the point quicker
I don't have much to say other than the fact that people now use extensions to find cooking recipes quicker in the stupid blog messes.

## -----END MANIFESFTO DUMP-----
TL;DR avoid bloating your website, use less CSS and JS, be concise.

Following this manifesto, you can make a nice experience with the horrible web pages we have today without swithing to Gopher or the little known Gemini.