---
title: "SIF1/2 archive"
layout: default
---

## Choose version
[SIF1 (Original)]({% link sifarchive/sif1/index.md %})

[SIF2 (Obfuscated colors)]({% link sifarchive/sif2/index.md %})

## Copy of the original post
The following is a copy of the post I made about this on my selfhosted site.

I've recently opened up a backup of my modded Minecraft servers and looked around in the OpenComputers directory,
and found some old image formats made by [Rph](https://rph.space).

## SIF
SIF stands for **S**imple **I**mage **F**ormat. It was made somewhere around early 2019.
SIF pictures only support 160x50 (the native OpenComputers resolution) and 240 colors. The 16 user-definable colors 
are unused. It was very slow, and images were really chunky. It was however a success.

You can find the various utilities for both SIF and SIF2 at the [SIF archive on this site]({% link sifarchive/index.md %})

## SIF2
SIF was generally identical to SIF, but had its colors obfuscated to prevent reverse engineering. Other than that,
there is no difference.

## PRIF
PRIF was really an experiment only. Rph doesn't even remember what it stands for, as it was really short-lived.
Instead of using regular pixels, PRIF would use UTF-8 half blocks to get twice as tall rendering. I only found
one decoder for it, and it wasn't really useful as there's no encoder for it, not even a single file that
you could use with it.

## SIF3
SIF3 was the next evolution of SIF, using Unicode Braille characters to get 320x200 picture rendering, and 256 colors when rendering with OpenComputers.
Technically, SIF3 did not have a color limit as colors were not simplified so 24-bit images could be produced.
SIF3 hasn't been uploaded to the SIF archive yet, this page will be updated when I do so.

## FIF
FIF is the **F**ast **I**mage **F**ormat, recently open-sourced by Rph. It supports very fast rendering of images, and can compress images by simplifying colors and actually being a bytecode format.
You can get the [encoder here](https://github.com/fifoc/encoder) and [OpenOS viewer here](https://github.com/fifoc/standalone-viewer).

## Verdict
With FIF having near instant image rendering thanks to buffers (and now even video!), a lot of OpenComputers applications can now become a reality.

It was fun seeing how each next generation brought more features, speed and higher resolution.

