const fs = require('fs');
const argv = process.argv.slice(2);
const input = argv[0];
const output = argv[1];
const PNG = require('pngjs').PNG;

let lastplace = 0
let data = fs.readFileSync(input);
let png = PNG.sync.read(data);

if (png.width > 255) {
    throw new Error("Unsupported width.");
}

let pixeldata = []

for (var x=0;x<png.width;x++) {
    pixeldata[x] = []
    for (var y=0;y<png.height;y++) {
        var idx = (png.width * y + x) << 2;
        pixeldata[x][y] = {
            r: png.data[idx],
            g: png.data[idx + 1],
            b: png.data[idx + 2]
        }
    }
}

let out = Buffer.alloc(1 + (png.width * png.height * 3));

console.log(pixeldata);

out.writeUInt8(png.width, lastplace);
lastplace++;
for (var y=0;y<png.height;y++) {
    for (var x=0;x<png.width;x++) {
        out.writeUInt8(pixeldata[x][y].r, lastplace);
        lastplace++;
        out.writeUInt8(pixeldata[x][y].g, lastplace);
        lastplace++;
        out.writeUInt8(pixeldata[x][y].b, lastplace);
        lastplace++;
    }
}

fs.writeFileSync(output, out);

