const fs = require('fs');
const argv = process.argv.slice(2);
const input = argv[0];
const output = argv[1];
const PNG = require('pngjs').PNG;

let lastplace = 0
let data = fs.readFileSync(input);
let png = PNG.sync.read(data);

if (png.width > 255) {
	throw new Error("Unsupported width.");
}

let pixeldata = []
function diff(o, n) {
	let c = n - o
	let retval = 0
	if (c >= 0) {
		retval = c;
	} else {
		retval = 255 - Math.abs(c);
	}
	return retval;
}

let oldr = 0;
let oldg = 0;
let oldb = 0;
for (var y=0;y<png.height;y++) {
	for (var x=0;x<png.width;x++) {
		if (!pixeldata[x]) {
			pixeldata[x] = [];
		}
		var idx = (png.width * y + x) << 2;
		pixeldata[x][y] = {
			r: diff(oldr, png.data[idx]),
			g: diff(oldg, png.data[idx + 1]),
			b: diff(oldb, png.data[idx + 2])
		}
		oldr = png.data[idx];
		oldg = png.data[idx + 1];
		oldb = png.data[idx + 2];
	}
}

let out = Buffer.alloc(2 + (png.width * png.height * 3));


out.writeUInt8(png.width, lastplace);
lastplace++;
function write(p) {
	console.log(p + " " + lastplace);
	out.writeUInt8(p, lastplace);
	lastplace++;
}
function r(x,y) {
	write(pixeldata[x][y].r);
}
function g(x,y) {
	write(pixeldata[x][y].g);
}
function b(x,y) {
	write(pixeldata[x][y].b);
}
let pix = 1;
for (var y=0;y<png.height;y++) {
	for (var x=0;x<png.width;x++) {
		let block = false;
		if (pix == 1) {
			r(x,y);
			g(x,y);
			b(x,y);
			block = true;
			pix = 2;
		}
		if (pix == 2 && block == false) {
			b(x,y);
			r(x,y);
			g(x,y);
			block = true;
			pix = 3;
		}
		if (pix == 3 && block == false) {
			g(x,y);
			b(x,y);
			r(x,y);
			block = true;
			pix = 4;
		}
		if (pix == 4 && block == false) {
			b(x,y);
			g(x,y);
			r(x,y);
			block = true;
			pix = 5;
		}
		if (pix == 5 && block == false) {
			g(x,y);
			r(x,y);
			b(x,y);
			block = true;
			pix = 6;
		}
		if (pix == 6 && block == false) {
			r(x,y);
			b(x,y);
			g(x,y);
			pix = 1;
		}
	}
}

out.writeUInt8("125", lastplace);

fs.writeFileSync(output, out);
